// Copyright (c) The Avalonia Project. All rights reserved.
// Licensed under the MIT license. See licence.md file in the project root for full license information.


namespace Avalonia.Media
{
    /// <summary>
    /// Defines a set of predefined colors.
    /// </summary>
    public sealed class Colors
    {
        /// <summary>
        /// Gets a color with an ARGB value of #fff0f8ff.
        /// </summary>
        public static Color AliceBlue => KnownColor.AliceBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffaebd7.
        /// </summary>
        public static Color AntiqueWhite => KnownColor.AntiqueWhite.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00ffff.
        /// </summary>
        public static Color Aqua => KnownColor.Aqua.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff7fffd4.
        /// </summary>
        public static Color Aquamarine => KnownColor.Aquamarine.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff0ffff.
        /// </summary>
        public static Color Azure => KnownColor.Azure.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff5f5dc.
        /// </summary>
        public static Color Beige => KnownColor.Beige.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffe4c4.
        /// </summary>
        public static Color Bisque => KnownColor.Bisque.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff000000.
        /// </summary>
        public static Color Black => KnownColor.Black.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffebcd.
        /// </summary>
        public static Color BlanchedAlmond => KnownColor.BlanchedAlmond.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff0000ff.
        /// </summary>
        public static Color Blue => KnownColor.Blue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff8a2be2.
        /// </summary>
        public static Color BlueViolet => KnownColor.BlueViolet.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffa52a2a.
        /// </summary>
        public static Color Brown => KnownColor.Brown.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdeb887.
        /// </summary>
        public static Color BurlyWood => KnownColor.BurlyWood.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff5f9ea0.
        /// </summary>
        public static Color CadetBlue => KnownColor.CadetBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff7fff00.
        /// </summary>
        public static Color Chartreuse => KnownColor.Chartreuse.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffd2691e.
        /// </summary>
        public static Color Chocolate => KnownColor.Chocolate.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff7f50.
        /// </summary>
        public static Color Coral => KnownColor.Coral.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff6495ed.
        /// </summary>
        public static Color CornflowerBlue => KnownColor.CornflowerBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffff8dc.
        /// </summary>
        public static Color Cornsilk => KnownColor.Cornsilk.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdc143c.
        /// </summary>
        public static Color Crimson => KnownColor.Crimson.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00ffff.
        /// </summary>
        public static Color Cyan => KnownColor.Cyan.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00008b.
        /// </summary>
        public static Color DarkBlue => KnownColor.DarkBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff008b8b.
        /// </summary>
        public static Color DarkCyan => KnownColor.DarkCyan.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffb8860b.
        /// </summary>
        public static Color DarkGoldenrod => KnownColor.DarkGoldenrod.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffa9a9a9.
        /// </summary>
        public static Color DarkGray => KnownColor.DarkGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff006400.
        /// </summary>
        public static Color DarkGreen => KnownColor.DarkGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffbdb76b.
        /// </summary>
        public static Color DarkKhaki => KnownColor.DarkKhaki.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff8b008b.
        /// </summary>
        public static Color DarkMagenta => KnownColor.DarkMagenta.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff556b2f.
        /// </summary>
        public static Color DarkOliveGreen => KnownColor.DarkOliveGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff8c00.
        /// </summary>
        public static Color DarkOrange => KnownColor.DarkOrange.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff9932cc.
        /// </summary>
        public static Color DarkOrchid => KnownColor.DarkOrchid.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff8b0000.
        /// </summary>
        public static Color DarkRed => KnownColor.DarkRed.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffe9967a.
        /// </summary>
        public static Color DarkSalmon => KnownColor.DarkSalmon.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff8fbc8f.
        /// </summary>
        public static Color DarkSeaGreen => KnownColor.DarkSeaGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff483d8b.
        /// </summary>
        public static Color DarkSlateBlue => KnownColor.DarkSlateBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff2f4f4f.
        /// </summary>
        public static Color DarkSlateGray => KnownColor.DarkSlateGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00ced1.
        /// </summary>
        public static Color DarkTurquoise => KnownColor.DarkTurquoise.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff9400d3.
        /// </summary>
        public static Color DarkViolet => KnownColor.DarkViolet.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff1493.
        /// </summary>
        public static Color DeepPink => KnownColor.DeepPink.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00bfff.
        /// </summary>
        public static Color DeepSkyBlue => KnownColor.DeepSkyBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff696969.
        /// </summary>
        public static Color DimGray => KnownColor.DimGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff1e90ff.
        /// </summary>
        public static Color DodgerBlue => KnownColor.DodgerBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffb22222.
        /// </summary>
        public static Color Firebrick => KnownColor.Firebrick.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffffaf0.
        /// </summary>
        public static Color FloralWhite => KnownColor.FloralWhite.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff228b22.
        /// </summary>
        public static Color ForestGreen => KnownColor.ForestGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff00ff.
        /// </summary>
        public static Color Fuchsia => KnownColor.Fuchsia.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdcdcdc.
        /// </summary>
        public static Color Gainsboro => KnownColor.Gainsboro.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff8f8ff.
        /// </summary>
        public static Color GhostWhite => KnownColor.GhostWhite.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffd700.
        /// </summary>
        public static Color Gold => KnownColor.Gold.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdaa520.
        /// </summary>
        public static Color Goldenrod => KnownColor.Goldenrod.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff808080.
        /// </summary>
        public static Color Gray => KnownColor.Gray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff008000.
        /// </summary>
        public static Color Green => KnownColor.Green.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffadff2f.
        /// </summary>
        public static Color GreenYellow => KnownColor.GreenYellow.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff0fff0.
        /// </summary>
        public static Color Honeydew => KnownColor.Honeydew.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff69b4.
        /// </summary>
        public static Color HotPink => KnownColor.HotPink.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffcd5c5c.
        /// </summary>
        public static Color IndianRed => KnownColor.IndianRed.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff4b0082.
        /// </summary>
        public static Color Indigo => KnownColor.Indigo.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffffff0.
        /// </summary>
        public static Color Ivory => KnownColor.Ivory.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff0e68c.
        /// </summary>
        public static Color Khaki => KnownColor.Khaki.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffe6e6fa.
        /// </summary>
        public static Color Lavender => KnownColor.Lavender.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffff0f5.
        /// </summary>
        public static Color LavenderBlush => KnownColor.LavenderBlush.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff7cfc00.
        /// </summary>
        public static Color LawnGreen => KnownColor.LawnGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffffacd.
        /// </summary>
        public static Color LemonChiffon => KnownColor.LemonChiffon.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffadd8e6.
        /// </summary>
        public static Color LightBlue => KnownColor.LightBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff08080.
        /// </summary>
        public static Color LightCoral => KnownColor.LightCoral.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffe0ffff.
        /// </summary>
        public static Color LightCyan => KnownColor.LightCyan.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffafad2.
        /// </summary>
        public static Color LightGoldenrodYellow => KnownColor.LightGoldenrodYellow.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffd3d3d3.
        /// </summary>
        public static Color LightGray => KnownColor.LightGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff90ee90.
        /// </summary>
        public static Color LightGreen => KnownColor.LightGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffb6c1.
        /// </summary>
        public static Color LightPink => KnownColor.LightPink.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffa07a.
        /// </summary>
        public static Color LightSalmon => KnownColor.LightSalmon.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff20b2aa.
        /// </summary>
        public static Color LightSeaGreen => KnownColor.LightSeaGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff87cefa.
        /// </summary>
        public static Color LightSkyBlue => KnownColor.LightSkyBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff778899.
        /// </summary>
        public static Color LightSlateGray => KnownColor.LightSlateGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffb0c4de.
        /// </summary>
        public static Color LightSteelBlue => KnownColor.LightSteelBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffffe0.
        /// </summary>
        public static Color LightYellow => KnownColor.LightYellow.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00ff00.
        /// </summary>
        public static Color Lime => KnownColor.Lime.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff32cd32.
        /// </summary>
        public static Color LimeGreen => KnownColor.LimeGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffaf0e6.
        /// </summary>
        public static Color Linen => KnownColor.Linen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff00ff.
        /// </summary>
        public static Color Magenta => KnownColor.Magenta.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff800000.
        /// </summary>
        public static Color Maroon => KnownColor.Maroon.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff66cdaa.
        /// </summary>
        public static Color MediumAquamarine => KnownColor.MediumAquamarine.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff0000cd.
        /// </summary>
        public static Color MediumBlue => KnownColor.MediumBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffba55d3.
        /// </summary>
        public static Color MediumOrchid => KnownColor.MediumOrchid.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff9370db.
        /// </summary>
        public static Color MediumPurple => KnownColor.MediumPurple.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff3cb371.
        /// </summary>
        public static Color MediumSeaGreen => KnownColor.MediumSeaGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff7b68ee.
        /// </summary>
        public static Color MediumSlateBlue => KnownColor.MediumSlateBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00fa9a.
        /// </summary>
        public static Color MediumSpringGreen => KnownColor.MediumSpringGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff48d1cc.
        /// </summary>
        public static Color MediumTurquoise => KnownColor.MediumTurquoise.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffc71585.
        /// </summary>
        public static Color MediumVioletRed => KnownColor.MediumVioletRed.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff191970.
        /// </summary>
        public static Color MidnightBlue => KnownColor.MidnightBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff5fffa.
        /// </summary>
        public static Color MintCream => KnownColor.MintCream.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffe4e1.
        /// </summary>
        public static Color MistyRose => KnownColor.MistyRose.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffe4b5.
        /// </summary>
        public static Color Moccasin => KnownColor.Moccasin.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffdead.
        /// </summary>
        public static Color NavajoWhite => KnownColor.NavajoWhite.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff000080.
        /// </summary>
        public static Color Navy => KnownColor.Navy.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffdf5e6.
        /// </summary>
        public static Color OldLace => KnownColor.OldLace.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff808000.
        /// </summary>
        public static Color Olive => KnownColor.Olive.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff6b8e23.
        /// </summary>
        public static Color OliveDrab => KnownColor.OliveDrab.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffa500.
        /// </summary>
        public static Color Orange => KnownColor.Orange.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff4500.
        /// </summary>
        public static Color OrangeRed => KnownColor.OrangeRed.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffda70d6.
        /// </summary>
        public static Color Orchid => KnownColor.Orchid.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffeee8aa.
        /// </summary>
        public static Color PaleGoldenrod => KnownColor.PaleGoldenrod.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff98fb98.
        /// </summary>
        public static Color PaleGreen => KnownColor.PaleGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffafeeee.
        /// </summary>
        public static Color PaleTurquoise => KnownColor.PaleTurquoise.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdb7093.
        /// </summary>
        public static Color PaleVioletRed => KnownColor.PaleVioletRed.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffefd5.
        /// </summary>
        public static Color PapayaWhip => KnownColor.PapayaWhip.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffdab9.
        /// </summary>
        public static Color PeachPuff => KnownColor.PeachPuff.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffcd853f.
        /// </summary>
        public static Color Peru => KnownColor.Peru.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffc0cb.
        /// </summary>
        public static Color Pink => KnownColor.Pink.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffdda0dd.
        /// </summary>
        public static Color Plum => KnownColor.Plum.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffb0e0e6.
        /// </summary>
        public static Color PowderBlue => KnownColor.PowderBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff800080.
        /// </summary>
        public static Color Purple => KnownColor.Purple.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff0000.
        /// </summary>
        public static Color Red => KnownColor.Red.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffbc8f8f.
        /// </summary>
        public static Color RosyBrown => KnownColor.RosyBrown.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff4169e1.
        /// </summary>
        public static Color RoyalBlue => KnownColor.RoyalBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff8b4513.
        /// </summary>
        public static Color SaddleBrown => KnownColor.SaddleBrown.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffa8072.
        /// </summary>
        public static Color Salmon => KnownColor.Salmon.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff4a460.
        /// </summary>
        public static Color SandyBrown => KnownColor.SandyBrown.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff2e8b57.
        /// </summary>
        public static Color SeaGreen => KnownColor.SeaGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffff5ee.
        /// </summary>
        public static Color SeaShell => KnownColor.SeaShell.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffa0522d.
        /// </summary>
        public static Color Sienna => KnownColor.Sienna.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffc0c0c0.
        /// </summary>
        public static Color Silver => KnownColor.Silver.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff87ceeb.
        /// </summary>
        public static Color SkyBlue => KnownColor.SkyBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff6a5acd.
        /// </summary>
        public static Color SlateBlue => KnownColor.SlateBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff708090.
        /// </summary>
        public static Color SlateGray => KnownColor.SlateGray.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fffffafa.
        /// </summary>
        public static Color Snow => KnownColor.Snow.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff00ff7f.
        /// </summary>
        public static Color SpringGreen => KnownColor.SpringGreen.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff4682b4.
        /// </summary>
        public static Color SteelBlue => KnownColor.SteelBlue.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffd2b48c.
        /// </summary>
        public static Color Tan => KnownColor.Tan.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff008080.
        /// </summary>
        public static Color Teal => KnownColor.Teal.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffd8bfd8.
        /// </summary>
        public static Color Thistle => KnownColor.Thistle.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffff6347.
        /// </summary>
        public static Color Tomato => KnownColor.Tomato.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #00ffffff.
        /// </summary>
        public static Color Transparent => KnownColor.Transparent.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff40e0d0.
        /// </summary>
        public static Color Turquoise => KnownColor.Turquoise.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffee82ee.
        /// </summary>
        public static Color Violet => KnownColor.Violet.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff5deb3.
        /// </summary>
        public static Color Wheat => KnownColor.Wheat.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffffff.
        /// </summary>
        public static Color White => KnownColor.White.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #fff5f5f5.
        /// </summary>
        public static Color WhiteSmoke => KnownColor.WhiteSmoke.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ffffff00.
        /// </summary>
        public static Color Yellow => KnownColor.Yellow.ToColor();

        /// <summary>
        /// Gets a color with an ARGB value of #ff9acd32.
        /// </summary>
        public static Color YellowGreen => KnownColor.YellowGreen.ToColor();
    }
}
